import { GeneralParamDict, GeneralSegmentDict } from './route-match';
export declare function isQueryIdsMatched(a: string | symbol | true, b: string | symbol | true): boolean;
export declare function buildPath(segmentDict: GeneralSegmentDict, paramDict?: GeneralParamDict): string;
export declare function buildRef(pathMap: Map<string | undefined, string>, queryMap: Map<string, string | undefined> | undefined): string;
export interface ParseRefResult {
    pathname: string;
    search: string;
    hash: string;
}
export declare function parseRef(ref: string): ParseRefResult;
export declare function parseSearch(search: string): Map<string, string>;
export declare function testPathPrefix(path: string, prefix: string): boolean;
export declare type ToleratedReturnType<TOriginalReturnType> = TOriginalReturnType extends Promise<infer T> ? Promise<T | undefined> | undefined : TOriginalReturnType | undefined;
export declare function tolerate<T extends (...args: any[]) => any>(fn: T, ...args: Parameters<T>): ToleratedReturnType<ReturnType<T>>;
