import { AbstractHistory, HistorySnapshot } from './history';
export interface MemoryHistoryOptions {
    /**
     * Initial ref, defaults to '/'.
     */
    initialRef?: string;
    /**
     * URL prefix.
     */
    prefix?: string;
}
export declare class MemoryHistory<TData = any> extends AbstractHistory<number, TData> {
    private _snapshot;
    private lastId;
    private prefix;
    constructor({ initialRef, prefix }?: MemoryHistoryOptions);
    get snapshot(): HistorySnapshot<number, TData>;
    getHRefByRef(ref: string): string;
    getRefByHRef(href: string): string;
    back(): Promise<void>;
    forward(): Promise<void>;
    push(ref: string, data?: TData): Promise<void>;
    replace(ref: string, data?: TData): Promise<void>;
    restore(snapshot: HistorySnapshot<number, TData>, toEmitChange?: boolean): Promise<void>;
}
