"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReadOnlyHistory = void 0;
const history_1 = require("./history");
class ReadOnlyHistory extends history_1.AbstractHistory {
    constructor({ prefix = '' } = {}) {
        super();
        Object.defineProperty(this, "snapshot", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "prefix", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.prefix = prefix;
        let id = 0;
        this.snapshot = {
            entries: [
                {
                    id,
                    ref: '/',
                    data: undefined,
                },
            ],
            active: id,
        };
    }
    getHRefByRef(ref) {
        return `${this.prefix}${ref}`;
    }
    getRefByHRef(href) {
        let prefix = this.prefix;
        return href.startsWith(prefix) ? href.slice(prefix.length) : href;
    }
    back() {
        throw new Error('Method not implemented');
    }
    forward() {
        throw new Error('Method not implemented');
    }
    push() {
        throw new Error('Method not implemented');
    }
    replace() {
        throw new Error('Method not implemented');
    }
    restore() {
        throw new Error('Method not implemented');
    }
}
exports.ReadOnlyHistory = ReadOnlyHistory;
//# sourceMappingURL=readonly-history.js.map