import { EmptyObjectPatch } from 'tslang';
import { GeneralParamDict, RouteMatchShared, RouteMatchSharedToParamDict } from './route-match';
import { Router, RouterNavigateOptions } from './router';
export interface RouteBuilderBuildingPart {
    route: RouteMatchShared;
    params?: GeneralParamDict;
}
export declare type RouteBuilderSourceType = 'current' | 'next' | 'none';
export declare class RouteBuilder<TGroupName extends string = string> {
    private router;
    private sourceType;
    private buildingParts;
    private leavingGroupSet;
    constructor(router: Router<TGroupName>, sourceType: RouteBuilderSourceType, buildingParts?: (RouteBuilderBuildingPart | string)[], leavingGroupSet?: Set<string>);
    /**
     * Route of the first building part if available.
     */
    get $route(): RouteMatchShared | undefined;
    $<TRouteMatchShared extends RouteMatchShared>(route: TRouteMatchShared, params?: Partial<RouteMatchSharedToParamDict<TRouteMatchShared>> & EmptyObjectPatch): RouteBuilder<TGroupName>;
    $(part: string): RouteBuilder<TGroupName>;
    $leave(groups: TGroupName | TGroupName[]): RouteBuilder<TGroupName>;
    $ref(): string;
    $href(): string;
    /**
     * Perform a `history.push()` with `this.$ref()`.
     */
    $push(options?: RouterNavigateOptions): void;
    /**
     * Perform a `history.replace()` with `this.$ref()`.
     */
    $replace(options?: RouterNavigateOptions): void;
}
